// EncDec_AES.cpp : R\[ AvP[ṼGg |Cg`܂B
//
// Copyright (c) LЃgXgE\tgEFAEVXe, All Rights reserved.
//

#include "stdafx.h"
#include <Windows.h>
#include <Bcrypt.h>

#pragma comment(lib,"Bcrypt.lib")

#define	NT_SUCCESS(Status)		(((NTSTATUS)(Status)) >= 0)
#define	STATUS_UNSUCCESSFULL	((NTSTATUS)0xC0000001L)


int _tmain(int argc, _TCHAR* argv[])
{
	BCRYPT_ALG_HANDLE	hAlg = NULL;
	NTSTATUS	status = STATUS_UNSUCCESSFULL;

	// Open an algorithm handle.
	status = BCryptOpenAlgorithmProvider(&hAlg, BCRYPT_AES_ALGORITHM, NULL, 0);
	if(NT_SUCCESS(status)) {
		printf("OK\n");
	} else {
		printf("*** Error 0x%x returned by BCryptOpenAlgorithmProvider\n", status);
		return 1;
	}

	// L[IuWFNgi[̈̃TCY擾
	DWORD	cbKeyObj;
	ULONG	cbData;

	status = BCryptGetProperty(hAlg, BCRYPT_OBJECT_LENGTH, (PBYTE)&cbKeyObj, sizeof(DWORD), &cbData, 0);
	if(NT_SUCCESS(status)) {
		printf("The key object size is %d.\n", cbKeyObj);
	} else {
		printf("*** Error 0x%x returned by BCryptGetProperty\n", status);
		return 1;
	}

	// ̈m
	PBYTE	pbKeyObj;

	pbKeyObj = (PBYTE)HeapAlloc(GetProcessHeap(), 0, cbKeyObj);
	if(!pbKeyObj) {
		printf("*** memory allocation failed\n");
		return 1;
	}

	// get Initialization Vector size
	static const BYTE	rgbIV[] = {
		0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
		0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F
	};
	DWORD	cbBlockLen;
	PBYTE	pbIV;

	status = BCryptGetProperty(hAlg, BCRYPT_BLOCK_LENGTH, (PBYTE)&cbBlockLen, sizeof(DWORD), &cbData, 0);
	if(NT_SUCCESS(status)) {
		printf("The blocklength is %d.\n", cbBlockLen);
	} else {
		printf("*** Error 0x%x returned by BCryptGetProperty\n", status);
		return 1;
	}

	// Allocate for IV
	pbIV = (PBYTE)HeapAlloc(GetProcessHeap(), 0, cbBlockLen);
	if(!pbIV) {
		printf("*** memory allocation failed\n");
		return 1;
	}
	memcpy(pbIV, rgbIV, cbBlockLen);


	// ÍIvV
	static const BYTE	rgbAES128Key[] = {
		0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
		0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F
	};

	status = BCryptSetProperty( hAlg, BCRYPT_CHAINING_MODE, (PBYTE)BCRYPT_CHAIN_MODE_CBC, sizeof(BCRYPT_CHAIN_MODE_CBC), 0);
	if(NT_SUCCESS(status)) {
		printf("OK\n");
	} else {
		printf("*** Error 0x%x returned by BCryptSetProperty\n", status);
		return 1;
	}

	// key object for encryption
	BCRYPT_KEY_HANDLE	hKey = NULL;

	status = BCryptGenerateSymmetricKey(hAlg, &hKey, pbKeyObj, cbKeyObj, (PBYTE)rgbAES128Key, sizeof(rgbAES128Key), 0);
	if(NT_SUCCESS(status)) {
		printf("OK\n");
	} else {
		printf("*** Error 0x%x returned by BCryptGenerateSymmetricKey\n", status);
		return 1;
	}

	// f[^̃Rs[쐬
	DWORD	cbBlob;
	PBYTE	pbBlob;

	status = BCryptExportKey(hKey, NULL, BCRYPT_OPAQUE_KEY_BLOB, NULL, 0, &cbBlob, 0);
	if(NT_SUCCESS(status)) {
		printf("The key size is %d\n", cbBlob);
	} else {
		printf("*** Error 0x%x returned by BCryptExportKey\n", status);
		return 1;
	}

	pbBlob = (PBYTE)HeapAlloc(GetProcessHeap(), 0, cbBlob);
	if(!pbBlob) {
		printf("*** memory allocation failed\n");
		return 1;
	}

	status = BCryptExportKey(hKey, NULL, BCRYPT_OPAQUE_KEY_BLOB, pbBlob, cbBlob, &cbData, 0);
	if(NT_SUCCESS(status)) {
		printf("The key size is %d\n", cbData);
	} else {
		printf("*** Error 0x%x returned by BCryptExportKey\n", status);
		return 1;
	}

	// Í
	static const BYTE rgbPlainText[] = {
		0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
		0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F
	};
	DWORD	cbCipherText;
	PBYTE	pbCipherText;

	status = BCryptEncrypt(hKey, (PBYTE)rgbPlainText, sizeof(rgbPlainText), NULL, pbIV, cbBlockLen, NULL, 0, &cbCipherText, BCRYPT_BLOCK_PADDING);
	if(NT_SUCCESS(status)) {
		printf("The buffre size is %d\n", cbCipherText);
	} else {
		printf("*** Error 0x%x returned by BCryptExportKey\n", status);
		return 1;
	}

	pbCipherText = (PBYTE)HeapAlloc(GetProcessHeap(), 0, cbCipherText);
	if(!pbCipherText) {
		printf("*** memory allocation failed\n");
		return 1;
	}

	status = BCryptEncrypt(hKey, (PBYTE)rgbPlainText, sizeof(rgbPlainText), NULL, pbIV, cbBlockLen, pbCipherText, cbCipherText, &cbData, BCRYPT_BLOCK_PADDING);
	if(!NT_SUCCESS(status)) {
		printf("*** Error 0x%x returned by BCryptExportKey\n", status);
		return 1;
	}

	// n
	status = BCryptDestroyKey(hKey);
	if(!NT_SUCCESS(status)) {
		printf("*** Error 0x%x returned by BCryptDestroyKey\n", status);
		return 1;
	}

	//	
	hKey = 0;
	memset(pbKeyObj, 0, cbKeyObj);
	memcpy(pbIV, rgbIV, cbBlockLen);
	DWORD	cbPlainText;
	PBYTE	pbPlainText;

	// C|[g
	status = BCryptImportKey(hAlg, NULL, BCRYPT_OPAQUE_KEY_BLOB, &hKey, pbKeyObj, cbKeyObj, pbBlob, cbBlob, 0);
	if(!NT_SUCCESS(status)) {
		printf("*** Error 0x%x returned by BCryptImportKey\n", status);
		return 1;
	}

	status = BCryptDecrypt(hKey, pbCipherText, cbCipherText, NULL, pbIV, cbBlockLen, NULL, 0, &cbPlainText, BCRYPT_BLOCK_PADDING);
	if(NT_SUCCESS(status)) {
		printf("The output buffer size is %d.\n", cbPlainText);
	} else {
		printf("*** Error 0x%x returned by BCryptDecrypt\n", status);
		return 1;
	}

	pbPlainText = (PBYTE)HeapAlloc(GetProcessHeap(), 0, cbPlainText);
	if(!pbPlainText) {
		printf("*** memory allocation failed\n");
		return 1;
	}

	status = BCryptDecrypt(hKey, pbCipherText, cbCipherText, NULL, pbIV, cbBlockLen, pbPlainText, cbPlainText, &cbData, BCRYPT_BLOCK_PADDING);
	if(!NT_SUCCESS(status)) {
		printf("*** Error 0x%x returned by BCryptDecrypt\n", status);
		return 1;
	}

	return 0;
}

